cabal-install-solver-3.12.1.0: The command-line interface for Cabal and Hackage.

Safe Haskell | None
Language | Haskell2010

Distribution.Solver.Modular.Var

Synopsis

- data Var qpn
  - = P qpn
  - | F (FN qpn)
  - | S (SN qpn)
- showVar :: Var QPN -> String
- varPN :: Var qpn -> qpn

# Documentation

data Var qpn Source #

The type of variables that play a role in the solver. Note that the tree currently does not use this type directly, and rather has separate tree nodes for the different types of variables. This fits better with the fact that in most cases, these have to be treated differently.

Constructors

P qpn |
F (FN qpn) |
S (SN qpn) |

#### Instances

Instances details

Functor Var Source # |
Instance details Defined in Distribution.Solver.Modular.Var Methods fmap :: (a -> b) -> Var a -> Var b Source # (<$) :: a -> Var b -> Var a Source #
Show qpn => Show (Var qpn) Source # |
Instance details Defined in Distribution.Solver.Modular.Var Methods showsPrec :: Int -> Var qpn -> ShowS Source # show :: Var qpn -> String Source # showList :: [Var qpn] -> ShowS Source #
Eq qpn => Eq (Var qpn) Source # |
Instance details Defined in Distribution.Solver.Modular.Var Methods (==) :: Var qpn -> Var qpn -> Bool Source # (/=) :: Var qpn -> Var qpn -> Bool Source #
Ord qpn => Ord (Var qpn) Source # |
Instance details Defined in Distribution.Solver.Modular.Var Methods compare :: Var qpn -> Var qpn -> Ordering Source # (<) :: Var qpn -> Var qpn -> Bool Source # (<=) :: Var qpn -> Var qpn -> Bool Source # (>) :: Var qpn -> Var qpn -> Bool Source # (>=) :: Var qpn -> Var qpn -> Bool Source # max :: Var qpn -> Var qpn -> Var qpn Source # min :: Var qpn -> Var qpn -> Var qpn Source #

showVar :: Var QPN -> String Source #

varPN :: Var qpn -> qpn Source #

Extract the package name from a Var